//
//  BRBViewController.m
//  GDataSample
//
//  Created by Benjamin Black on 08/08/2012.
//  Copyright (c) 2012 Benjamin Black. All rights reserved.
//

#import "BRBViewController.h"
#import "GData.h"
#import "GTMOAuth2ViewControllerTouch.h"


@interface BRBViewController ()

@end

@implementation BRBViewController

@synthesize textView;

static NSString *const kMyProductName = @"GDataSample";
static NSString *const kMyClientID = @"698615171359.apps.googleusercontent.com"; // pre-assigned by service
static NSString *const kMyClientSecret = @"k8FOZVJtmotwF2AH6pRpAlIS"; // pre-assigned by service
static NSString *const scope = @"https://spreadsheets.google.com/feeds https://docs.google.com/feeds";

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.

}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (IBAction)connect:(id)sender
{
    GTMOAuth2Authentication *auth = [GTMOAuth2ViewControllerTouch authForGoogleFromKeychainForName:kMyProductName
                                                                 clientID:kMyClientID
                                                             clientSecret:kMyClientSecret];
    BOOL isSignedIn = [auth canAuthorize];
    
    if (isSignedIn) {
        textView.text = @"success";
        
        GDataServiceGoogleSpreadsheet *service = [[GDataServiceGoogleSpreadsheet alloc] init];
        [service setAuthorizer:auth];
        
        // this code will fetch your spreadsheet feed
        //NSURL *feedURL = [NSURL URLWithString:kGDataGoogleSpreadsheetsPrivateFullFeed];
        //[service fetchFeedWithURL:feedURL
        //                delegate:self
        //        didFinishSelector:@selector(feedTicket:finishedWithFeed:error:)];
        
        
        GDataServiceGoogleDocs *docService = [[GDataServiceGoogleDocs alloc] init];
        [docService setAuthorizer:auth];
        
        NSURL *docFeedURL = [GDataServiceGoogleDocs docsFeedURL];
        
        // this code will create a spreadsheet
        [docService fetchFeedWithURL:docFeedURL completionHandler:^(GDataServiceTicket *ticket, GDataFeedBase *feed, NSError *error) {
            GDataFeedDocList *docList = (GDataFeedDocList *)feed;
            
            GDataEntryDocBase *newEntry = [[GDataEntryDocBase alloc] init];
            [newEntry setTitleWithString:@"document.cvs"];
            [newEntry setUploadMIMEType:@"text/csv"];
            NSData *data = [@"Date,Done" dataUsingEncoding:NSUTF8StringEncoding];
            [newEntry setUploadData:data];

             NSURL *postURL = [[docList postLink] URL];
            
            [service fetchEntryByInsertingEntry:newEntry
                                     forFeedURL:postURL
                              completionHandler:^(GDataServiceTicket *ticket, GDataEntryBase *entry, NSError *error) {
                                  // callback
                                  if (error == nil) {
                                      textView.text = @"created document.cvs";
                                  } else {
                                      textView.text = @"failed to create document";
                                  }
                              }];
            
        }];
        
    } else {
        GTMOAuth2ViewControllerTouch *viewController;
        viewController = [[GTMOAuth2ViewControllerTouch alloc] initWithScope:scope
                                                                clientID:kMyClientID
                                                            clientSecret:kMyClientSecret
                                                        keychainItemName:kMyProductName
                                                                delegate:self
                                                        finishedSelector:@selector(viewController:finishedWithAuth:error:)];
    
        [[self navigationController] pushViewController:viewController animated:YES];
        
        textView.text = @"signing in...";
    }

}

- (void)viewController:(GTMOAuth2ViewControllerTouch *)viewController finishedWithAuth:(GTMOAuth2Authentication *)auth
                 error:(NSError *)error {
    if (error != nil) {
        textView.text = @"fail";
        NSLog(@"fail");
    } else {
        textView.text = @"success";
        NSLog(@"success");
    }
}

- (void)feedTicket:(GDataServiceTicket *)ticket
  finishedWithFeed:(GDataFeedSpreadsheet *)feed
             error:(NSError *)error
{
    NSArray *entries = [feed entries];
    
    for (GDataEntrySpreadsheet *object in entries) {
        textView.text = object.title.stringValue;
    }
}

@end
